/**
 * Sigma.js WebGL Renderer Quadratic Bezier Edge Program
 * ======================================================
 * @module
 */
import { EdgeAttributes, NodeAttributes } from "../../../types";
import { AbstractEdgeProgram, RenderEdgeParams } from "./common/edge";
export default class EdgeQuadraticBezierProgram extends AbstractEdgeProgram {
    positionLocation: GLint;
    colorLocation: GLint;
    coordLocation: GLint;
    matrixLocation: WebGLUniformLocation;
    resolutionLocation: WebGLUniformLocation;
    ratioLocation: WebGLUniformLocation;
    scaleLocation: WebGLUniformLocation;
    constructor(gl: WebGLRenderingContext);
    bind(): void;
    computeIndices(): void;
    process(sourceData: NodeAttributes, targetData: NodeAttributes, data: EdgeAttributes, hidden: boolean, offset: number): void;
    render(params: RenderEdgeParams): void;
}
